
package Reflector;


import java.io.*;
import java.lang.reflect.*;

import jasmin.*;

import java.util.*;



public class ReflectorJasmin extends ReflectorReflection implements Reflector_Interface
{
	//jasminpăoCgR[h̓Iɂ郊tNV̑ւs.

	final static Hashtable<Method, ReflectorJasminProxy> proxyTable = new Hashtable();


	final static boolean DEBUG_MODE = false;	//oCgR[h\.


	public Object invoke(Object instance,	Method method,	Object[] args) throws java.lang.Exception
	{
		
		ReflectorJasminProxy proxy = proxyTable.get( method );


		if ( proxy == null )
		{

			try
			{
				String proxyName = defineProxyClassName( instance, method );


				String jasminCode = generateCode_ProxyJasmin( proxyName, instance.getClass().getName(), method.getName(), ReflectorTools.isStaticMethod(method), method.getReturnType(), method.getParameterTypes()  );

				
				byte[] bytes = assembleJasmin( jasminCode );


				if ( DEBUG_MODE )
				{
					Reflector.DisAssembler.DisJasminBCEL disasm = new Reflector.DisAssembler.DisJasminBCEL();
					String disAssembleCode = disasm.disassemble( bytes );
					System.out.println("=========================\n\n\n");
					System.out.println( disAssembleCode );
					System.out.println("=========================\n\n\n");
				}


				Class proxyCls = ReflectorJavassist.byteCodeToClass( bytes );
				proxy = (ReflectorJasminProxy)proxyCls.newInstance();
				
				proxyTable.put( method, proxy );
			}
			catch(Exception e )
			{
				e.printStackTrace();
				return null;
			}
		}

		Object ret = null;
			
		ret = proxy.invoke( instance, args );

		return ret;
	}


	
	public String defineProxyClassName( Object instance, Method method )
	{


		String targetClassPath	= instance.getClass().getName();
		String[] paths		= targetClassPath.split("\\.");

		// String name = "ReflectorJasminProxy_" + instance.getClass().getName()  + "_" + method.getName();
		 String name = "ReflectorJasminProxy_" + paths[ paths.length - 1]  + "_" + method.getName();

		Class[] paramTypes = method.getParameterTypes();
		for( int i=0; i < paramTypes.length; i++)
		{
			name += "_" + paramTypes[i].getName();
		}

		name = name.replace( ".", "_");
		name = name.replace( ";", "_");
		
		name = name.replace("[", "");


		if ( paths.length >= 2 )
		{
			String packName = "";
			for( int i=0; i < paths.length - 1; i++)
			{
				packName += paths[ i ] + ".";
			}
			name  = packName + name;
		}


		return name;
	}




   /**
     * Called to assemble a single file.
     * @param fname is the name of the file containing the Jasmin source code.
     */
    public static byte[] assembleJasmin( String jasminSrcCode )
    {
        // FileOutputStream outp = null;
	OutputStream outp = null;

        ClassFile classFile = new ClassFile();
        String iocause = ": file not found";

	String encoding = null;

	String fname = "OnMemory";

        try {
            BufferedReader inp;
            {

              // FileInputStream fs = new FileInputStream(fname);
		InputStream fs = new StringBufferInputStream( jasminSrcCode );

              InputStreamReader ir;
              if(encoding == null)
                ir = new InputStreamReader(fs);
              else
                ir = new InputStreamReader(fs, encoding);
              inp = new BufferedReader(ir);
            }

            // classFile.readJasmin(inp, file.getName(), generate_linenum);
		boolean generate_linenum = false;	//Autogenerate linenumbers
		classFile.readJasmin( inp,  fname,  generate_linenum );

            inp.close();

            // if we got some errors, don't output a file - just return.
            if (classFile.errorCount() > 0) {
                System.err.println(fname + ": Found "
                                    + classFile.errorCount() + " errors");
                return null;
            }



	/*

            String class_path[] = (ScannerUtils.splitClassField(
                                                classFile.getClassName()));
            String class_name = class_path[1];

            // determine where to place this class file
            String dest_dir = dest_path;
            if (class_path[0] != null) {
                String class_dir = ScannerUtils.convertChars(
                                           class_path[0], "./",
                                           File.separatorChar);
                if (dest_dir != null) {
                    dest_dir = dest_dir + File.separator + class_dir;
                } else {
                    dest_dir = class_dir;
                }
            }
            iocause = class_name + ".class: file can't be created";

            if (dest_dir == null) {
                out_file = new File(class_name + ".class");
            } else {
                out_file = new File(dest_dir, class_name + ".class");

                // check that dest_dir exists

                File dest = new File(dest_dir);
                if (!dest.exists()) {
                    dest.mkdirs();
                }

                if (!dest.isDirectory()) {
                    throw new IOException("Cannot create directory");
                }
            }

            outp = new FileOutputStream(out_file);
	*/

	outp = new ByteArrayOutputStream();

            classFile.write(outp);

            // outp.close();
            // outp = null; // as marker

            // System.out.println("Generated: " + out_file.getPath());

        } catch (java.io.FileNotFoundException e) {
            System.err.println(iocause);
            System.exit(-1);
	
        }
	/*
	catch (jasError e)
	{
            classFile.report_error("JAS Error: " + e.getMessage(), e.numTag);
        }
	*/
	catch (Exception e) {
		/*
	        if(DEBUG)
		{
                	e.printStackTrace();
		}
		*/

	/*
            classFile.report_error(fname + ": exception - <" +
                              e.getClass().getName() + "> " + e.getMessage() +
                              ".");
	*/

		System.err.println("Jasmin Assemble ERROR.\n" + fname + ": exception - <" + e.getClass().getName() + "> " + e.getMessage() + ".");

        }
        if (classFile.errorCount() > 0) {
            System.err.println(fname + ": Found "
                               + classFile.errorCount() + " errors");
            if (outp != null) {
                try {
                  // outp.close();
                  // out_file.delete();
                } catch(Exception e) {}
            }
        }

	return ( (ByteArrayOutputStream)outp ).toByteArray();
    }


	public int hello_1(String message )
	{
		System.out.println("Hello. This is ReflectorJasmin#hello_1():message=\"" + message + "\", message.length()=" + message.length() );
		return message.length();
	}


	public static void main(String[] args)
	{

		// String src = generateCode_HelloJasmin();

		ReflectorJasmin rj_obj = new ReflectorJasmin();

		String src = generateCode_ProxyJasmin( "JasminProxy_001", rj_obj.getClass().getName(), "hello_1", false, Integer.TYPE, new Class[]{ String.class } );


		System.out.println("========= Jasmin Source ==================");
		System.out.println( src );
		System.out.println("==========================================");

		ReflectorJasmin rj = new ReflectorJasmin();
		byte[] bytes = rj.assembleJasmin( src );

		System.out.println("generated Java bytecode " + bytes.length + " Bytes" );

		Class cls = ReflectorJavassist.byteCodeToClass( bytes );

		System.out.println("cls=" + cls );
		
		try
		{
			Object obj = cls.newInstance();
			ReflectorJasminProxy proxy = (ReflectorJasminProxy)obj;
			proxy.invoke( (Object)rj, new Object[]{ (Object)"Hello" } );
		}
		catch(Exception e )
		{
			e.printStackTrace(System.err);
		}

	}


	static String generateCode_HelloJasmin()
	{
		String src = "";

		src += "; file:\"hello.j\"\n";

		src += "; --- NX hello ̒` ---\n";
		src += ".class public hello\n";

		src += ".super java/lang/Object\n";


		src += "; --- \bh ---\n";
		src += ".method public <init>()V\n";
		src += "   aload_0\n";
		src += "   invokenonvirtual java/lang/Object/<init>()V\n";
		src += "   return\n";
		src += ".end method\n";

		src += "; --- ÓI main \bh ---\n";
		src += ".method public static main([Ljava/lang/String;)V\n";
		src += "   .limit stack 2\n";
		src += "   ; --- \ ---\n";
		src += "  ; java.lang.System.out(\"Hello, World!\") Ɠ\n";
		src += "   getstatic java/lang/System/out Ljava/io/PrintStream;\n";
		src += "   ldc \"Hello,World!\"\n";
		src += "   invokevirtual java/io/PrintStream/println(Ljava/lang/String;)V\n";
		src += "   return\n";
		src += ".end method\n";
		
		return src;
	}


	static String generateCode_ProxyJasmin( String className, String targetClassName, String targetMethodName, boolean isStaticMethod, Class retType, Class[] paramTypes )
	{

		targetClassName = targetClassName.replace(".", "/");
		className	= className.replace(".", "/" );


		String src = "";

		src += "; file:\"hello.j\"\n";

		src += "; --- NX̒` ---\n";

		//src += ".class public hello\n";
		src += ".class public " + className + "\n";

		// src += ".super java/lang/Object \n";
		src += ".super " + targetClassName.replace("." , "/") + " \n";

		src += ".implements Reflector/ReflectorJasminProxy \n";


		/*
		src += "; --- \bh ---\n";
		src += ".method public <init>()V\n";
		src += "   aload_0\n";
		src += "   invokenonvirtual java/lang/Object/<init>()V\n";
		src += "   return\n";
		src += ".end method\n";
		*/

		
		
		src += "; --- \bh ---\n";
		src += ".method public <init>()V \n";
		src += "	.limit stack 1 \n";
		src += "	.limit locals 1 \n";
		src += "	.var 0 is this L" + className.replace("." , "/") + "; from Label0 to Label1 \n";

		src += "	Label0: \n";
		src += ".line 5 \n";
		src += "	aload_0 \n";
		src += "	invokespecial "+ targetClassName.replace("." , "/")  + "/<init>()V \n";

		src += "Label1: \n";
		src += "return \n";
		src += ".end method \n";
		




		src += "; --- IvLV\bh ---\n";
		src += ".method public invoke(Ljava/lang/Object;[Ljava/lang/Object;)Ljava/lang/Object; \n";
		src += "	.limit stack 128 \n";
		src += "	.limit locals 128 \n";


		src += "	aconst_null \n";
		src += "	astore_3 \n";

		src += "	aload_1 \n";
		src += "	checkcast " + targetClassName + " \n";

				
		src += "	" + genParamsCastCode( paramTypes );

		// src += 		"invokevirtual Reflector/DisAssembler/DisJasminBCEL/Hello1(Ljava/lang/String;I)J \n";
		src += "	" + genInvokeCode( isStaticMethod, targetClassName, targetMethodName, retType, paramTypes ) + "\n";


		// src += 		"invokestatic java/lang/Long/valueOf(J)Ljava/lang/Long; \n";
		if ( retType.isPrimitive() )
		{
			src += "	" + convertPrimObjCode( retType ) + "\n";
		}

		src +=	"	astore_3 \n";

		src += 	"	aload_3 \n";

		src += 	"	areturn \n";

		src += ".end method \n";


		src += "\n";

		src += "; --- ÓI main \bh ---\n";
		src += ".method public static main([Ljava/lang/String;)V\n";
		src += "   .limit stack 2\n";
		src += "   ; --- \ ---\n";
		src += "  ; java.lang.System.out(\"Hello, World!\") Ɠ\n";
		src += "   getstatic java/lang/System/out Ljava/io/PrintStream;\n";
		src += "   ldc \"Hello,World!\"\n";
		src += "   invokevirtual java/io/PrintStream/println(Ljava/lang/String;)V\n";
		src += "   return\n";
		src += ".end method\n";
		
		return src;
	}


	private static String genParamsCastCode( Class[] paramTypes )
	{
		//\bḧz񂩂擾ēK؂Ȍ^ɃLXgX^bNɐςރR[h𐶐

		String code = "; z񂩂X^bNɐςޏ\n";

		for( int i=0; i < paramTypes.length; i++)
		{
			code += "	aload_2 \n";
			code += "	iconst_" + i + " \n";
			code += "	aaload \n";

			if ( paramTypes[i].isPrimitive() == false )
			{
				code += "checkcast " + paramTypes[i].getName().replace("." , "/" ) + " \n";
			}
			else
			{
				if ( paramTypes[i] == Boolean.TYPE )
				{
					code += "	checkcast " + Boolean.class.getName().replace(".", "/") + "\n";
					code += "	invokevirtual " + Boolean.class.getName().replace(".", "/") + "/booleanValue()Z \n";
				}
				else if ( paramTypes[i] == Byte.TYPE )
				{
					code += "	checkcast " + Byte.class.getName().replace(".", "/") + "\n";
					code += "	invokevirtual " + Byte.class.getName().replace(".", "/") + "/byteValue()B \n";
				}
				else if ( paramTypes[i] == Short.TYPE )
				{
					code += "	checkcast " + Short.class.getName().replace(".", "/") + "\n";
					code += "	invokevirtual " + Short.class.getName().replace(".", "/") + "/shortValue()S \n";
				}
				else if ( paramTypes[i] == Character.TYPE )
				{
					code += "	checkcast " + Character.class.getName().replace(".", "/") + "\n";
					code += "	invokevirtual " + Character.class.getName().replace(".", "/") + "/charValue()C \n";
				}
				else if ( paramTypes[i] == Integer.TYPE )
				{
					code += "	checkcast " + Integer.class.getName().replace(".", "/") + "\n";
					code += "	invokevirtual " + Integer.class.getName().replace(".", "/") + "/intValue()I \n";

				}
				else if ( paramTypes[i] == Long.TYPE )
				{
					code += "	checkcast " + Long.class.getName().replace(".", "/") + "\n";
					code += "	invokevirtual " + Long.class.getName().replace(".", "/") + "/longValue()J \n";
				}
				else if ( paramTypes[i] == Float.TYPE )
				{
					code += "	checkcast " + Float.class.getName().replace(".", "/") + "\n";
					code += "	invokevirtual " + Float.class.getName().replace(".", "/") + "/floatValue()F \n";
				}
				else if ( paramTypes[i] == Double.TYPE )
				{
					code += "	checkcast " + Double.class.getName().replace(".", "/") + "\n";
					code += "	invokevirtual " + Double.class.getName().replace(".", "/") + "/doubleValue()D \n";
				}
			}

		}

		code += "; ܂\n";
		return code;
	}

	private static String genInvokeCode( boolean isStatic, String targetClassName, String targetMethodName, Class retType, Class[] paramTypes )
	{

		String code = "\n";

		if ( isStatic )
		{
			code += "	invokestatic ";
		}
		else
		{
			code += "	invokevirtual ";
		}

		code += targetClassName.replace("." , "/") + "/" + targetMethodName + "(" + genSignature( paramTypes ) + ")" + genSignature( new Class[]{ retType } );

		return code;
	}

	private static String genSignature( Class[] types )
	{
		String sig = "";


		Class[] primTypes	= { Boolean.TYPE, Byte.TYPE, Short.TYPE, Character.TYPE, Integer.TYPE, Long.TYPE, Float.TYPE, Double.TYPE, Void.TYPE };
		String[] primSigs	= { "Z", "B", "S", "C", "I", "J", "F", "D", "V" };

		for( int i=0; i < types.length; i++)
		{
			if ( types[i].isPrimitive() == false )
			{
				sig += "L" + types[i].getName().replace("." , "/") + ";" ;
			}
			else
			{
				for( int k=0; k < primTypes.length; k++)
				{
					if ( types[i] == primTypes[k] )
					{
						sig += primSigs[k];
						break;
					}
					
				}
			}
		}

		return sig;
	}


	private static String convertPrimObjCode( Class type )
	{
		// v~eBu^̕ϐNXɕϊR[h.
		Class[] primTypes	= { Boolean.TYPE, Byte.TYPE, Short.TYPE, Character.TYPE, Integer.TYPE, Long.TYPE, Float.TYPE, Double.TYPE };
		Class[] primClasses	= { Boolean.class, Byte.class, Short.class, Character.class, Integer.class, Long.class, Float.class, Double.class };

		String code = "";

		for( int i=0; i < primTypes.length; i++)
		{
			if ( type == primTypes[i] )
			{
				code += "	invokestatic " + primClasses[i].getName().replace(".", "/") + "/valueOf(" + genSignature( new Class[]{ type } ) + ")" + "L" + primClasses[i].getName().replace(".", "/") + ";" +  "\n";
				break;
			}
		}

		code += "\n";
		
		return code;
	}
	
	





/*

; JavaCompilerAPINXptN^ProxyNXtAZu
; JasmintN^悻̌`ɏătNV.
; Produced by NeoJasminVisitor (tinapoc)
; http://tinapoc.sourceforge.net
; The original JasminVisitor is part of the BCEL
; http://jakarta.apache.org/bcel/
; Tue Feb 02 19:06:58 JST 2010

.bytecode 50.0
.source ReflectorJavaCompilerAPI_Reflector_DisAssembler_DisJasminBCEL_Hello1_java_lang_String_int.java from JavaSourceFromString
.class public Reflector/DisAssembler/ReflectorJavaCompilerAPI_Reflector_DisAssembler_DisJasminBCEL_Hello1_java_lang_String_int
.super Reflector/DisAssembler/DisJasminBCEL
.implements Reflector/ReflectorJavaCompilerAPIProxy




.method public <init>()V
    .limit stack 1
    .limit locals 1
    .var 0 is this LReflector/DisAssembler/ReflectorJavaCompilerAPI_Reflector_DisAssembler_DisJasminBCEL_Hello1_java_lang_String_int; from Label0 to Label1

    
    Label0:
.line 5
    aload_0
    invokespecial Reflector/DisAssembler/DisJasminBCEL/<init>()V

    Label1:
    return

.end method



.method public invoke(Ljava/lang/Object;[Ljava/lang/Object;)Ljava/lang/Object;
    .limit stack 4
    .limit locals 4
    .var 0 is this LReflector/DisAssembler/ReflectorJavaCompilerAPI_Reflector_DisAssembler_DisJasminBCEL_Hello1_java_lang_String_int; from Label0 to Label1
    .var 1 is arg0 Ljava/lang/Object; from Label0 to Label1
    .var 2 is arg1 [Ljava/lang/Object; from Label0 to Label1

    
    Label0:
.line 7
    aconst_null
    astore_3

    .line 8
    aload_1
    checkcast Reflector/DisAssembler/DisJasminBCEL
    aload_2
    iconst_0
    aaload
    checkcast java/lang/String
    aload_2
    iconst_1
    aaload
    checkcast java/lang/Integer
    invokevirtual java/lang/Integer/intValue()I
    invokevirtual Reflector/DisAssembler/DisJasminBCEL/Hello1(Ljava/lang/String;I)J
    invokestatic java/lang/Long/valueOf(J)Ljava/lang/Long;
    astore_3

    .line 9
    aload_3

    Label1:
    areturn

.end method



.method public getValue()Ljava/lang/String;
    .limit stack 1
    .limit locals 1
    .var 0 is this LReflector/DisAssembler/ReflectorJavaCompilerAPI_Reflector_DisAssembler_DisJasminBCEL_Hello1_java_lang_String_int; from Label0 to Label1

    
    Label0:
.line 12
    ldc "sɃt@Cg킸RpCI"

    Label1:
    areturn

.end method
*/



}