
package Reflector;

import java.lang.reflect.*;


import javax.tools.JavaCompiler;
import javax.tools.ToolProvider;


import java.io.IOException;
import java.security.SecureClassLoader;
import java.util.*;

import javax.tools.*;
import javax.tools.JavaFileObject.Kind;

import javax.tools.SimpleJavaFileObject;

import java.io.*;
import java.net.URI;






//javax.tools.JavaCompilergpēIJavaNXt@C𐶐ėp邽߂̃NX.
//http://www.ne.jp/asahi/hishidama/home/tech/java/JavaCompiler.htmlɏL.


public class ReflectorJavaCompilerAPI extends ReflectorReflectionWithCache
//public class ReflectorJavaCompilerAPI extends ReflectorReflection
{

	static Hashtable<Method, ReflectorJavaCompilerAPIProxy> proxyTable = new Hashtable();
	// w肵\bhĂяovLXNX̎̂i[e[u.

	static Hashtable<Class, JavaClassObject> proxyClassObjectTable = new Hashtable();
	// {tN^ŐvLVNX̃oCgR[hȂǂi[e[u.
	// [hς݂̃vLVNXClass^ƁAYJavaClassObject^Ήtĕۑ.

	final static boolean DEBUG_MODE = false;	//oCgR[h\.


	public byte[] getBytecode(Class cls )
	{
		//{tN^ŐJavaoCgR[hԂ.

		byte[] bytecode = null;

		JavaClassObject clsObj = proxyClassObjectTable.get( cls );

		if ( clsObj != null )
		{
			bytecode = clsObj.getBytes();
		}

		return bytecode;
	}


	private static String defineClassName( Object instance, Method method )
	{
		//ReflectorJavaCompilerAPIProxypvLVNX̃NX肷.

		
		String name = "ReflectorJavaCompilerAPI_" + instance.getClass().getName()  + "_" + method.getName();

		Class[] paramTypes = method.getParameterTypes();
		for( int i=0; i < paramTypes.length; i++)
		{
			name += "_" + paramTypes[i].getName();
		}

		name = name.replace( ".", "_");
		name = name.replace( ";", "_");
		
		name = name.replace("[", "");



		return name;
	}


	private static String makeProxySource(Object instance, Method method )
	{
		// ReflectorJavaCompilerAPIProxypvLVNX̃\[X𐶐.

		String src = "";

		if ( instance.getClass().getPackage() != null )
		{
			//src	+= "package Reflector;\n";
			src	+= "package " + instance.getClass().getPackage().getName() + ";\n";

			src	+= "import " + instance.getClass().getName() + ";\n";

		}

		src	+= "import Reflector.ReflectorJavaCompilerAPIProxy;\n";
		src	+= "import Reflector.*;\n";

		
		String clsName = defineClassName( instance, method );

		//src	+=	"public class " + clsName + " extends ReflectorJavaCompilerAPIProxy {\n";
		//src	+=	"public class " + clsName + " implements ReflectorJavaCompilerAPIProxy";							// ^[QbgNXpȂꍇ.
		src	+=	"public class " + clsName + " extends " + instance.getClass().getName() + " implements ReflectorJavaCompilerAPIProxy";	//^[QbgNXpNXȂ


		src	+=	"{\n";

		src	+=		"public Object invoke( Object instance, Object[] params) {\n";



		// src	+=		"	System.out.println(\"HelloJavac\");\n";

		src	+=	"	Object ret = null;\n";

		if ( method.getReturnType().getName().equals("void") == false )
		{

			src	+=		"	ret =";
			src	+=			"(Object)";
		}


		src	+=			"( (" + instance.getClass().getName() + ")instance )." + method.getName();
		src	+=				"(";


		Class[] paramTypes = method.getParameterTypes();
		for( int i=0; i < paramTypes.length; i++)
		{
			Class	paramType = paramTypes[i];
			String cast ="";

			String[] primitiveTypes = { "boolean","byte","char","short","int","long", "float", "double" };
			String[] rapperTypes	= { "Boolean", "Byte", "Char", "Short", "Integer", "Long", "Float", "Double" };

			if ( !paramType.isPrimitive() )
			{
				// cast +=" (" + paramType.getName() + ")params[" + i + "]";

				String type =  paramType.getName();
				if ( type.indexOf("[") >= 0 )
				{
					//z^̏ꍇ "[Ljava.lang.String;" Ȃǂ̂悤ɕ\LĂ̂ŁA"java.lang.String[]"ȂǂɏCKvL.
					type = type.replace("[L", "");
					type = type.replace("[", "");
					type = type.replace(";", "");
					type = type + "[]";
				}

				cast += " (" + type + ")params[" + i + "]";

			}
			else
			{
				for( int k=0; k < primitiveTypes.length; k++)
				{
					if ( paramType.getName().equals(primitiveTypes[k] ) )
					{
						cast +=" ((" + rapperTypes[k] + ")params[" + i + "] )." + primitiveTypes[k] + "Value()";
					}
				}
			}

			if ( i+1 != method.getParameterTypes().length )
			{
				cast +=",";
			}
			src += cast;
		}



		src	+=				")";



		src	+=			";\n";
		
		src	+=			"return ret;\n";
		src	+=		"}\n";

		src	+=	"public String getValue() {\n";
		src	+=	"return \"sɃt@Cg킸RpCI\";\n";
		src	+=	"}\n";

		src	+=	"}\n";
		

		return src;
		

	}

	public Object invoke(Object instance,	Method method,	Object[] args) throws java.lang.Exception
	{
		ReflectorJavaCompilerAPIProxy proxy = proxyTable.get( method );

		if ( proxy == null )
		{

			/*
			String clsName = defineClassName( instance, method );

			String src = makeProxySource( instance, method );

			// System.err.println(src);

			String packageName = "";
			if ( instance.getClass().getPackage() != null )
			{
				packageName = instance.getClass().getPackage().getName();
				packageName += ".";
			}


			Class<ReflectorJavaCompilerAPIProxy> c = null;
			try
			{
				c = compile( packageName + clsName, src );
			}
			catch (Exception e )
			{
				e.printStackTrace(System.err);
				System.err.println(src);
				throw e;
			}
			*/

			Class<ReflectorJavaCompilerAPIProxy> c = compileProxyClass( instance, method );
			
			proxy = c.newInstance();
			
			proxyTable.put( method, proxy );


			if ( DEBUG_MODE )
			{
				byte[] byteCode = getBytecode( c );
				Reflector.DisAssembler.DisJasminBCEL disasm = new Reflector.DisAssembler.DisJasminBCEL();
				String jasminCode = disasm.disassemble( byteCode );
				System.out.println("=========================\n\n\n");
				System.out.println( jasminCode );
				System.out.println("=========================\n\n\n");
			}

		}

		return proxy.invoke( instance, args );

	}


	public Class compileProxyClass(Object instance,	Method method ) throws java.lang.Exception
	{
		//ړĨvLVNXVKɍ쐬.

		Class<ReflectorJavaCompilerAPIProxy> c = null;

		String clsName = defineClassName( instance, method );

		String src = makeProxySource( instance, method );

		// System.err.println(src);

		String packageName = "";
		if ( instance.getClass().getPackage() != null )
		{
			packageName = instance.getClass().getPackage().getName();
			packageName += ".";
		}
		try
		{
			c = compile( packageName + clsName, src );
		}
		catch (Exception e )
		{
			e.printStackTrace(System.err);
			System.err.println(src);
			throw e;
		}

		return c;
	}



	protected DiagnosticListener<? super JavaFileObject> listener = new ErrorListener();

	protected JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();
	//  tools.jarNXpXɊ܂܂ĂȂꍇ, JREŎsnullA.

	/** RpCs */
	public <T> Class<T> compile(String class_name, String source_code) {
		JavaFileObject fo = new JavaSourceFromString(class_name, source_code);

		List<JavaFileObject> compilationUnits = Arrays.asList(fo);
		List<String> options = Arrays.asList(
					"-classpath", System.getProperty("java.class.path")
				);


		for( int i=0; i < options.size(); i++)
		{
			// System.err.println("ReflectorJavaCompilerAPI.compile() options.get(i)=" + options.get(i) );
		}


		JavaFileManager manager = new ClassFileManager(compiler, listener);
		JavaCompiler.CompilationTask task = compiler.getTask(
						null,
						manager,	//o̓t@C}l[W[
						listener,	//G[̏sXi[inullł悢j
						options,	//RpCIvV
						null,
						compilationUnits	//RpCΏۃt@CQ
					);

		//RpCs
		boolean successCompile = task.call();
		if (!successCompile) {
			throw new RuntimeException("RpCsF" + class_name);
		}

		ClassLoader cl = manager.getClassLoader(null);
		try {
			@SuppressWarnings("unchecked")
			Class<T> c = (Class<T>)cl.loadClass(class_name);


			JavaClassObject clsObj = ( (ClassFileManager)manager ).map.get( c.getName() );
			this.proxyClassObjectTable.put( c, clsObj);
			// 10/02/01ǉ.
			// ă[hς݂JavaNXɊւ(oCgR[h̎̂܂){tN^ŕۊǂ邱Ƃɂ.


			return c;
		} catch (ClassNotFoundException e) {
			throw new RuntimeException(e);
		}
	}




	public void compileTest()
	{
		// \[X𐶐
		StringWriter sw = new StringWriter();
		PrintWriter pw = new PrintWriter(sw);

		pw.println("package Reflector;");

		pw.println("import Reflector.ReflectorJavaCompilerAPIProxy;");
		pw.println("public class Sample3 extends ReflectorJavaCompilerAPIProxy {");
		pw.println("public String getValue() {");

		pw.println("Reflector.ReflectorCoTest rct = new Reflector.ReflectorCoTest();");

		pw.println("return \"sɃt@Cg킸RpCI\";");
		pw.println("}");
		
		pw.println("public Object invoke( Object instance, Object[] params) {");
		pw.println("return null;");
		pw.println("}");

		pw.println("}");

		pw.close();
		String src = sw.toString();

		// System.out.print(src);1

		//RpCs
		
		Class<ReflectorJavaCompilerAPIProxy> c = compile("Reflector.Sample3", src); //LXgԈĂĂAł̓G[ɂȂȂ

		try
		{

			//CX^X𐶐ČĂяo
			ReflectorJavaCompilerAPIProxy s = c.newInstance();	//Class̃LXgԈĂAŗO
			System.out.println(s.getValue());
		}
		catch (Exception e )
		{
			e.printStackTrace();
		}
	
		return ;
	}

	public static void main(String[] args)
	{
		ReflectorJavaCompilerAPI rj = new ReflectorJavaCompilerAPI();

		rj.compileTest();



	}



}

/*
interface SampleInterface {

	public String getValue();
}


abstract class ReflectorJavaCompilerAPIProxy
{

	public abstract Object invoke( Object instance, Object[] params);

}
*/



class JavaSourceFromString extends SimpleJavaFileObject {
	/**
	 * ́ut@Cṽ\[XR[hB
	 */
	protected final String code;

	/**
	 * V JavaSourceFromString \zB
	 * 
	 * @param name
	 *	̃t@CIuWFNgŕ\RpCjbg̃NXiFQCNj
	 * @param code
	 *	̃t@CIuWFNgŕ\RpCjbg̃\[XR[h
	 */
	public JavaSourceFromString(String name, String code) {
		super(URI.create("string:///" + name.replace('.', '/') + Kind.SOURCE.extension), Kind.SOURCE);
		this.code = code;
	}

	@Override
	public CharSequence getCharContent(boolean ignoreEncodingErrors) {
		return code;
	}
}


class JavaClassObject extends SimpleJavaFileObject
{

	public JavaClassObject(String name, Kind kind) {
		super(URI.create("string:///" + name.replace('.', '/') + kind.extension), kind);
	}

	protected final ByteArrayOutputStream bos = new ByteArrayOutputStream();

	// ۂ̏o͗pXg[Ԃ
	@Override
	public OutputStream openOutputStream() throws IOException {
		return bos;
	}

	// RpCꂽoCgR[h
	public byte[] getBytes() {
		return bos.toByteArray();
	}

	/** [hꂽNX */
	private Class<?> clazz = null;

	public void setDefinedClass(Class<?> c) {
		clazz = c;
	}

	public Class<?> getDefinedClass() {
		return clazz;
	}
}


class ErrorListener implements DiagnosticListener<JavaFileObject> {

	// RpCG[NƂɌĂ΂
	public void report(Diagnostic<? extends JavaFileObject> diagnostic) {
		System.out.println("report start");
		System.out.println("errcodeF" + diagnostic.getCode());
		System.out.println("line   F" + diagnostic.getLineNumber());
		System.out.println("column F" + diagnostic.getColumnNumber());
		System.out.println("messageF" + diagnostic.getMessage(null));
		//System.out.println(diagnostic.toString());
		System.out.println("report end");
	}
}


class ClassFileManager extends ForwardingJavaFileManager<JavaFileManager>
{

	public ClassFileManager(JavaCompiler compiler, DiagnosticListener<? super JavaFileObject> listener) {
		super(compiler.getStandardFileManager(listener, null, null) );
	}

	/** L[FNXAlFNXt@C̃IuWFNg */
	protected final Map<String, JavaClassObject> map = new HashMap<String, JavaClassObject>();

	// NXt@C𐶐ƂɌĂ΂
	@Override
	public JavaFileObject getJavaFileForOutput(Location location, String className, Kind kind, FileObject sibling) throws IOException {
		JavaClassObject co = new JavaClassObject(className, kind);
		map.put(className, co); // NXL[ɂăt@CIuWFNgێĂ
		return co;
	}

	protected ClassLoader loader = null;

	@Override
	public ClassLoader getClassLoader(Location location) {
		if (loader == null) {
			loader = new Loader();
		}
		return loader;
	}

	/** RpCNXԂׂ̃NX[_[ */
	private class Loader extends SecureClassLoader {

		@Override
		protected Class<?> findClass(String name) throws ClassNotFoundException {


			// System.out.println("ReflectorJavaCompilerAPI.java ClassFileManager.findClass() name=" + name );

			JavaClassObject co = map.get(name);
			if (co == null) {
				return super.findClass(name);
			}

			Class<?> c = co.getDefinedClass();
			if (c == null) {
				byte[] b = co.getBytes();

				try
				{
					c = super.defineClass(name, b, 0, b.length);
				}
				catch (java.lang.IllegalAccessError e )
				{
					c = ReflectorJavassist.byteCodeToClass( b );
					// @̂ClassLoader.defineClass()łpublicNXȊÕNXpNX̐Ɏs.
					//	āApublicNXȊÕNXpNX𓮓IꍇJavassistAPIpăoCgR[hClass^ւ̕ϊĂ.
				}

				co.setDefinedClass(c);
			}

			return c;
		}
	}
}




