

package Reflector;

import java.lang.reflect.*;
import java.util.concurrent.*;

public class ReflectorReflection implements Reflector_Interface
{
	//javasitptNV̑ւ.


	ReflectorTools tools = new ReflectorTools();

	public Object invoke(String className,	String methodName,	Object[] args) throws java.lang.Exception
	{
		//NX/\bhw肵ꍇ,ɃCX^X𐶐Ăs.

		Object ret = null;

		if ( args == null)
		{
			//Ȃꍇnullnꍇ
			args = new Object[0];
		}

		try {
			Class cls = Class.forName( className );

			Object inst = cls.newInstance();

			ret = invoke( inst, methodName, args);

		} catch (Exception e) {
			e.printStackTrace();

			printError(e);

			return null;
		}

		return ret;

	}

	public Object invoke(Object instance,	String methodName,	Object[] args) throws java.lang.Exception
	{
		//NX̓CX^Xς݂̂,\bhĂяo.

		Object ret = null;
		Method method = null;

		if ( args == null)
		{
			//Ȃꍇnullnꍇ
			args = new Object[0];
		}

		try {
			Class cls = instance.getClass();

			Object inst = instance;


			/*
			Class[] params = new Class[ args.length ];
			for( int i=0; i < params.length; i++)
			{
				//^Cv쐬
				params[i] = args[i].getClass();
			}

			Method method = cls.getMethod( methodName, params);
			*/

			method = ReflectorTools.getMethod( cls.getName(), methodName, args);

			ret = invoke( inst, method, args);

		} catch (Exception e) {
			e.printStackTrace();

			printError(e);


			// tools.printInvokeError( System.out, " ReflectorReflection.invoke(Object, Method, Object[]) is ERROR.", method );
			tools.printInvokeError( System.err, " ReflectorReflection.invoke(Object, Method, Object[]) is ERROR.", method );

			return null;
		}

		return ret;

	}



	public Object invoke(Object instance, Method method, Object[] args) throws java.lang.Exception
	{

		//ɑ݂CX^X𗘗pthis|C^ēn.
		//static\bh̏ꍇł,Ȃ.

		Object ret = null;
		
		try {

			ret = method.invoke( instance, (Object[])args);

		} catch (Exception e ) {

			// e.printStackTrace();

			StackTraceElement[] ste_arr = e.getStackTrace();
			for( int i = 0; i < ste_arr.length; i++ )
			{
				System.err.println( ste_arr[i] );
			}

			printError(e);

			// tools.printInvokeError( System.out, " ReflectorReflection.invoke(Object, Method, Object[]) is ERROR.", method );
			tools.printInvokeError( System.err, " ReflectorReflection.invoke(Object, Method, Object[]) is ERROR.", method );
		}

		return ret;

	}



	public Object[] invokeParallels(String className, String methodName, Object[][] argses) throws java.lang.Exception
	{
		//NX/\bhw肵ꍇ,ɃCX^X𐶐Ăs.

		Object[] rets = null;

		try {
			Class cls = Class.forName( className );

			Object inst = cls.newInstance();

			rets = invokeParallels( inst, methodName, argses);

		} catch (Exception e) {
			e.printStackTrace();

			printError(e);
			return null;
		}




		return rets;
	}

	public Object[] invokeParallels(Object instance, String methodName, Object[][] argses) throws java.lang.Exception
	{


		Object[] rets = null;


		if ( argses[0] == null)
		{
			argses[0] = new Object[0];
		}

		try {
			Class cls = instance.getClass();

			Object inst = instance;

			Method	method = ReflectorTools.getMethod( cls.getName(), methodName, argses[0]);

			rets = invokeParallels( inst, method, argses);

		} catch (Exception e) {
			e.printStackTrace();

			printError(e);

			return null;
		}

		

		return rets;
	}




	
	public Object[] invokeParallels(Object instance, Method method, Object[][] argses) throws java.lang.Exception
	{
		// 񏈗p.

		// System.err.println("ReflectorReflection.invokeParallels() argses.length=" + argses.length );

		if ( argses.length < 2)
		{
			return invokeParallelsNonThread( instance, method, argses);
		}


		Parallels[] ps = new Parallels[ argses.length ];
		for( int i=0; i < argses.length; i++)
		{
			ps[i] = new Parallels();
			ps[i].reflectorThreadStarter(instance, method, argses[i], this);
		}

		Object[] rets = new Object[argses.length];
		for( int i=0; i < rets.length; i++)
		{
			rets[i] = ps[i].getReturnValue();


		}

		
		return rets;
	}
	


	
	
	public Object[] invokeParallelsNonThread(Object instance, Method method, Object[][] argses) throws java.lang.Exception
	{
		//eXgp@Xbh

		Object[] rets = new Object[ argses.length ];
		
		for( int i =0; i < argses.length; i++)
		{
			rets[i] = invoke( instance, method, argses[i] );
		}

		return rets;
	}



	public Object[] invokeDiffParallels( String[] classNames, String[] methodNames, Object[][] argses ) throws java.lang.Exception
	{
		//NX/\bhw肵ꍇ,ɃCX^X𐶐Ăs.

		Object[] rets = null;

		try {

			Object[] instances = new Object[ classNames.length ];
			for( int i=0; i < classNames.length; i++)
			{
				Class cls = Class.forName( classNames[i] );
				instances[i] = cls.newInstance();
			}

			rets = invokeDiffParallels( instances, methodNames, argses);

		} catch (Exception e) {
			e.printStackTrace();

			printError(e);
			return null;
		}




		return rets;
	}





	public Object[] invokeDiffParallels( Object[] instances, String[] methodNames, Object[][] argses ) throws java.lang.Exception
	{


		Object[] rets = null;

		try {

			Method[] methods = new Method[ methodNames.length ];
			for( int i=0; i < methodNames.length; i++)
			{

				if ( argses[i] == null)
				{
					argses[i] = new Object[0];
				}

				Class cls = instances[i].getClass();
				Object inst = instances[i];
				methods[i] = ReflectorTools.getMethod( cls.getName(), methodNames[i], argses[i]);
			}

			rets = invokeDiffParallels( instances, methods, argses);

		} catch (Exception e) {
			e.printStackTrace();

			printError(e);

			return null;
		}

		

		return rets;
	}

	public Object[] invokeDiffParallels( Object[] instances, Method[] methods, Object[][] argses ) throws java.lang.Exception
	{
		// ̈قȂ郁\bhɏ.

		Parallels[] ps = new Parallels[ argses.length ];
		for( int i=0; i < argses.length; i++)
		{
			ps[i] = new Parallels();
			ps[i].reflectorThreadStarter(instances[i], methods[i], argses[i], this);
		}

		Object[] rets = new Object[argses.length];
		for( int i=0; i < rets.length; i++)
		{
			rets[i] = ps[i].getReturnValue();

		}

		return rets;
	}
	


	private class Parallels extends Thread
	{
		

		private Semaphore exit_flag = new Semaphore(1);
		private Object return_value = null;

		private Object instance;
		private Method method;
		private Object[] args;

		private boolean exit_operation = true;

		private Reflector_Interface reflector;

		public void run()
		{

			exit_operation = false;

			try {

				this.return_value = reflector.invoke( this.instance, this.method, this.args);

				exit_flag.release();
			} catch (Exception e) {
				e.printStackTrace();
			}

			exit_operation = true;

		}

		public void reflectorThreadStarter( Object instance, Method method, Object[] args, Reflector_Interface reflector) throws java.lang.Exception
		{

			
			try {
				exit_flag.acquire();

				this.exit_operation = false;


				this.instance = instance;
				this.method = method;
				this.args = args;

				this.reflector = reflector;

				this.start();
			} catch (Exception e) {
				System.out.println("reflectorThreadStarter() failed\n");
				e.printStackTrace();
			}

			return ;
		}

		public Object getReturnValue()
		{

			//System.out.println("ReflectorReflection.getReturnValue() called\n");
		
			try {
				exit_flag.acquire();


				//while(exit_operation != true)
				{
					//Z}tHȂǂpɓ邽.sv?

				}

				Object ret = return_value;
				exit_flag.release();

				return ret;
			} catch (Exception e) {

				System.out.println("ReflectorReflection.getReturnValue() failed\n");

				e.printStackTrace();
				return null;
			}
		}
	
	}








	public Object[] invokeChain(Object[] instances,	Method[] methods,	Object[][] argses) throws java.lang.Exception
	{

		// Ã\bh𒀎s.javassistō҂ł.

		Object[] ret_objs = null;
	
		try {

			ret_objs = new Object[ methods.length ];

			for( int i=0; i < methods.length; i++)
			{
				Object[] args = null;
				if ( argses != null )
				{
					args = argses[i];
				}

				ret_objs[i] = invoke( instances[i], methods[i], args );
			}
		} catch (Exception e ) {
			printError(e);
		}
		
		return ret_objs;

	}






	private void printError(Exception e)
	{

		System.err.println("ReflectorReflection invoke() failed\n");

		StackTraceElement[] ste_arr = e.getStackTrace();
		for( int i=0; i < ste_arr.length; i++)
		{
			System.err.println(ste_arr[i].toString() );
		}
	}




}
		

	
		
