

package Reflector;

import java.util.*;

import java.lang.reflect.*;

public class ReflectorReflectionWithCache extends ReflectorReflection
{
	//NX̕nătNVsۂɁANXɃ[h
	//ȑOɃ[hNX̃CX^X͕ێĂĎgp.

	//܂\bh擾LbVOĂ.


	final int	maxCacheSize = 	4096;
	//őLbVTCY


	private Vector<ClassCacheContainar> cache = new Vector();

	public Object invoke(String className,	String methodName,	Object[] args) throws java.lang.Exception
	{
		
		Object inst = getInstance( className );

		if ( inst == null)
		{
			//CX^X쐬s\
			return null;
		}

		return invoke( inst, methodName, args);
	}


	public Object invoke( Object instance, String methodName,	Object[] args) throws java.lang.Exception
	{
		String className = instance.getClass().getName();

		ClassCacheContainar cont = searchClassCacheContainar( className, this.cache );

		if ( cont == null)
		{
			cont = addCache( className, instance);

		}

		if ( cont == null)
		{
			return null;
		}

		Method	method = cont.getMethod( methodName, args);

		return invoke( instance, method, args);
	}



	private static ClassCacheContainar searchClassCacheContainar( String className, Vector<ClassCacheContainar> cache)
	{
		
		for(int i=0; i < cache.size(); i++)
		{
			ClassCacheContainar containar = (ClassCacheContainar)cache.get(i);

			if (	containar.className.equals(className) == true	)
			{

				return containar;
			}

		}

		return null;
	}


	private ClassCacheContainar	addCache(String className, Object instance )
	{

		//vvf.VɃ[hĒǉ.
		try {
			Class cls = Class.forName( className );

			Object inst = instance;
			if ( inst == null )
			{
				inst = cls.newInstance();
			}

			ClassCacheContainar cont = new ClassCacheContainar();
			cont.className = className;
			cont.instance = inst;
			cont.referenceCount = 1;

			if ( this.cache.size() < maxCacheSize )
			{

				//vfXgɒǉăCX^XԂ.
				this.cache.add( cont );
				this.cache = sortInstance( this.cache );
				return cont;
			}
			else
			{
				//vf͊MAX

				//ł̓XgɒǉȂǍ㓖YNXɑĂяoꂽꍇ...
				return cont;
			}

		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}

	}
	


	private Object getInstance(String className)
	{



		ClassCacheContainar containar = (ClassCacheContainar)searchClassCacheContainar( className, this.cache );

		if ( containar != null)
		{
			containar.referenceCount++;
			this.cache = sortInstance( this.cache );
			return containar.instance;
		}



		//vvf.VɃ[hĒǉ.
		try {
			Class cls = Class.forName( className );

			Object inst = cls.newInstance();
			
			ClassCacheContainar cont = new ClassCacheContainar();
			cont.className = className;
			cont.instance = inst;
			cont.referenceCount = 1;

			if ( this.cache.size() < maxCacheSize )
			{

				//vfXgɒǉăCX^XԂ.
				this.cache.add( cont );
				this.cache = sortInstance( this.cache );
				return inst;
			}
			else
			{
				//vf͊MAX

				//ł̓XgɒǉȂǍ㓖YNXɑĂяoꂽꍇ...
				return inst;
			}
			

			

		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}

	}


	private static Vector	sortInstance(Vector cache)
	{

		ClassCacheContainar	cnt1, cnt2;
		for( int i =0; i < cache.size() - 1; i++)
		{
			cnt1 = (ClassCacheContainar)cache.get(i);
			cnt2 = (ClassCacheContainar)cache.get(i + 1);

			if ( cnt1.referenceCount < cnt2.referenceCount )
			{
				cache.set(i, cnt2);
				cache.set(i + 1, cnt1);
				return sortInstance(cache);
				
			}
		}

		return cache;

	}
	

		

}

class ClassCacheContainar
{
	public String	className = "";
	public Object	instance = null;
	public long	referenceCount = 0;

	private Vector<MethodContainar>	methodCache = new Vector();


	public Method	getMethod( String methodName, Object[] params)
	{


		if ( params == null)
		{
			params = new Object[0];
		}

		Class[] paramTypes = new Class[ params.length ];
		for( int i=0; i < paramTypes.length; i++)
		{
			paramTypes[i] = params[i].getClass();
		}

		return getMethod( methodName, paramTypes );

	}

	private Method	getMethod( String methodName, Class[] paramTypes)
	{
		
		if ( paramTypes == null)
		{
			paramTypes = new Class[0];
		}

		MethodContainar mc = searchMethodContainar( methodName, paramTypes);

		if ( mc != null)
		{

			mc.referenceCount++;
			sortMethodCache( methodCache );
			return mc.method;
		}

		Method method = ReflectorTools.getMethod( this.className, methodName, paramTypes );

		if ( method == null)
		{
			return null;
		}

		addMethod( methodName, method);

		return method;

	}

	private MethodContainar searchMethodContainar( String methodName, Class[] paramTypes)
	{
		
		MethodContainar mc;

		for( int i=0; i < methodCache.size(); i++)
		{
			mc = methodCache.get(i);
			
			if ( mc.methodName.equals( methodName ) == true)
			{
				if ( ReflectorTools.methodParamsCompare( mc.method, paramTypes) == true)
				{
					return mc;
				}
			}
		}

		return null;
	}

	private static void sortMethodCache( Vector<MethodContainar> methodCache)
	{
		
		for( int i=0; i < methodCache.size() - 1; i++)
		{
			MethodContainar mc1 = methodCache.get(i);
			MethodContainar mc2 = methodCache.get(i+1);

			if ( mc1.referenceCount < mc2.referenceCount )
			{
				methodCache.set(i, mc2);
				methodCache.set(i+1, mc1);
				sortMethodCache( methodCache );
				return ;
			}

		}

		return ;
	}

		

		

	private void addMethod( String methodName, Method method)
	{
		
		MethodContainar mc = new MethodContainar();

		mc.methodName = new String( methodName );
		mc.method = method;
		mc.referenceCount = 1;

		methodCache.add( mc );

		return ;
	}
		
}

class MethodContainar
{
	public String	methodName = "";
	public long	referenceCount = 0;
	
	public Method	method;
}