

package Reflector;

public class ReflectorTest
{

	public static int test()
	{

		try {
			//Reflector_Interface ri = new ReflectorReflection();
			//Reflector_Interface ri = new ReflectorReflectionWithCache();
			// Reflector_Interface ri = new ReflectorJavassist();
			//Reflector_Interface	ri = new ReflectorJavaCompilerAPI();
			Reflector_Interface	ri = new ReflectorJasmin();

			Object ret;
		
			Object[] args = new Object[1];
			args[0] = new String("HelloReflector!");

	
			ret = ri.invoke("Reflector.ReflectorCoTest", "static_test", args);
			System.out.println("static_test() returned " + ret );
			
			ret = ri.invoke("Reflector.ReflectorCoTest", "non_static_test", args);
			System.out.println("non_static_test() returned " + ret );

			ret = ri.invoke("Reflector.ReflectorCoTest", "test3", null);
			System.out.println("non_static_test() returned " + ret );
			

			Object[] primitive_args = { (Integer)1, (Long)2L, (Boolean)true };
			ret = ri.invoke("Reflector.ReflectorCoTest", "primitive_test", primitive_args);
			System.out.println("primitive_tes() returned " + ret );

			Object[] static_primitive_args = { (Integer)1, (Long)2L, (Boolean)true };
			ret = ri.invoke( "Reflector.ReflectorCoTest", "static_primitive_test", static_primitive_args);
			System.out.println("static_primitive_test() returned " + ret );
	

			ReflectorCoTest rct = new ReflectorCoTest();
			rct.member = 7;
			ri.invoke( rct, "test3", null);

			args[0] = new TestInterfaceClass();
			ri.invoke( "Reflector.ReflectorCoTest", "interface_test", args );
		} catch (Exception e ) {
			e.printStackTrace();
		}

		return 0;
	}

	public static void main(String[] args)
	{
		for(int i=0; i < 1; i++)
		{
			test();
		}
	}


}

class ReflectorCoTest
{

	int member = 2;

	public static int static_test(String message)
	{
		System.out.println("static_test() " + message);
		return 1;
	}

	public int non_static_test(String message)
	{
		static_test( message );
		return 2;
	}

	public int test3()
	{
		static_test("static\bh member = " + member );
		return 3;
	}

	public int interface_test(TestInterface ti)
	{
		static_test("C^[tF[XeXg str = " + ti.str );
		return 4;
	}

	public int primitive_test( int x, long y, boolean z )
	{
		System.out.println("primitive_test() x=" + x + ", y=" + y + ", z=" + z  );
		return 777;
	}


	public static int static_primitive_test( int x, long y, boolean z )
	{
		System.out.println("static_primitive_test() x=" + x + ", y=" + y + ", z=" + z  );
		return 777;
	}





}


class		TestInterfaceClass implements TestInterface
{

}

interface	TestInterface
{
	public final String	str	= "TestInterface";
}
