
package Reflector.RtOptimizer;

import java.lang.reflect.*;
import java.util.*;

import soot.*;
import soot.Scene.*;
import soot.jimple.*;
import soot.jimple.toolkits.callgraph.*;

// sootɊւ{񌹂
// Soot g Java vO͂	http://sel.ist.osaka-u.ac.jp/~ishio/soot/
//


public class SootOptimizer
{
	// soott[[NpăoCgR[hœK{.

	public byte[] optimize(byte[] byteocde)
	{
		// oCgR[hœK{.
		//	܂.

		return null;
	}

	private SootClass getSootClass( Class cls )
	{
		//JVM̃NXv[SootClass𓾂.

		SootClass sootCls = Scene.v().loadClassAndSupport( cls.getName() );

		return sootCls;
	}

	public CallGraph getCallGraph( Body body )
	{
		//̃\bhŌĂяoĂ郁\bh̃R[Ot쐬.
		// ǂ͕s.


		CallGraph cg = new CallGraph();

		// Iterator<Edge> itr = cg.edgesOutOf( body.getMethod() );
		Iterator<Edge> itr = cg.edgesInto( body.getMethod() );

		for (Iterator<Edge> i = itr; i.hasNext();)
		{
			cg.addEdge( i.next());
		}

		System.out.println(cg.size());

		return cg;


	}

	private void transform( Body body )
	{
		//bodyNXɑ΂ϊ/œKs.

		/*
		cg (call graph) 
			R[OtD-whole-programIvVL̂ݎsD ꂽR[Ot́CScene.v().getCallGraph()ŎQƉ\D

		wjtp (whole jimple transformation pack) 
			S̉͂ɊÂϊtFCYD-whole-programIvVL̂ݎsD

		wjop (whole jimple optimization pack) 
			S̉͂ɊÂœKtFCYD-whole-programIvVL̂ݎsD

		wjap (whole jimple annotation pack) 
			S̉͂ɊÂttFCYD-whole-programIvVL̂ݎsD

		jtp (jimple transformatin pack) 
			\bhPʂ̕ϊtFCYDR[h̕ϊsꍇ́CɏǉD

		jop (jimple optimization pack) 
			\bhPʂ̍œKtFCYDe폈n߂pӂĂD

		jap (jimple annotation pack) 
			\bhPʂ̏ttFCYDe߂Ƃɒǉł Tag t^D ̏𗘗p͂sCVȏtsꍇ͂ɏǉD ȂC\[XR[h̍sԍ񂾂͓ŁC R}hCIvVƂ -keep-line-number n sԍ񂪐D
		*/


		// TestBodyTransformer NX̃CX^Xǉ
		// : TestBodyTransformer.v() ̓VOgԂ
		PackManager.v().getPack("jtp").add(
			new Transform("jtp.test", TestBodyTransformer.v()));





		System.out.println("=============œKO=====================");
		System.out.println(body);
		System.out.println();

		Pack pack_cg = PackManager.v().getPack("cg");
		//pack_cg.apply( body );


		Pack pack_wjtp = PackManager.v().getPack("wjtp");
		//pack_wjtp.apply( body );

		Pack pack_wjop = PackManager.v().getPack("wjop");
		pack_wjop.apply( body );

		Pack pack_wjap = PackManager.v().getPack("wjap");
		// pack_wjap.apply( body );

		
		Pack pack_jtp = PackManager.v().getPack("jtp");
		pack_jtp.apply( body );

		Pack pack_jop = PackManager.v().getPack("jop");
		//pack_jop.apply( body );

		Pack pack_jap = PackManager.v().getPack("jap");
		pack_jap.apply( body );
		

		

		System.out.println("=============œK=====================");
		System.out.println(body);

		// Transform transform = PackManager.v().getTransform( "wjop" );
		// transform.apply( body );

	}
	


	private Body getMethodBody( Class cls, Method method )
	{
		//ėpMethod^sootBodyNX𒊏o.

		SootClass sootCls = getSootClass( cls );
	
		Class[] paramsArray = method.getParameterTypes();

		List<Class> paramsList = new ArrayList();
		for( int i=0; i < paramsArray.length; i++)
		{
			paramsList.add( paramsArray[i] );
		}

		SootMethod smethod = sootCls.getMethod( method.getName(), paramsList );
		
		return getMethodBody( smethod );
	}
	private Body getMethodBody( SootMethod smethod )
	{
		//SootMethodBodyNX𒊏o.
		
		// return smethod.getActiveBody();
		return smethod.retrieveActiveBody();

	}




	public static void test_loadSootClass()
	{
		SootOptimizer stOpt = new SootOptimizer();
		SootClass sootCls = stOpt.getSootClass( Integer.class );
		System.out.println(sootCls.getName() );

	}

	public static void test_getMethodBody()
	{
		try
		{
			SootOptimizer stOpt = new SootOptimizer();
			SootClass sootCls = stOpt.getSootClass( Integer.class );
			Body body = stOpt.getMethodBody( Integer.class, Integer.class.getMethod( "intValue" ) );

			System.out.println(body);
		}
		catch(Exception e )
		{
			e.printStackTrace();
		}
		
	}

	public static void test_getCallGraph()
	{
		try
		{
			SootOptimizer stOpt = new SootOptimizer();
			SootClass sootCls = stOpt.getSootClass( Integer.class );

			Body body = stOpt.getMethodBody( Integer.class, Integer.class.getMethod( "intValue" ) );


			stOpt.getCallGraph( body );
		}
		catch(Exception e )
		{
			e.printStackTrace();
		}

	}

	public static void test_transform()
	{
		try
		{
			SootOptimizer stOpt = new SootOptimizer();
			SootClass sootCls = stOpt.getSootClass( Integer.class );
			Body body = stOpt.getMethodBody( Integer.class, Integer.class.getMethod( "intValue" ) );
			stOpt.transform( body );
		}
		catch(Exception e )
		{
			e.printStackTrace();
		}

	}

	public static void main(String[] args)
	{
		test_transform();
	}

}


