
import Reflector.*;

import java.util.*;




public class Performance
{


	// static Reflector_Interface[] reflector_arr = { new ReflectorReflection(), new ReflectorReflectionWithCache(), new ReflectorJavassist() };
	// static Reflector_Interface[] reflector_arr = { new ReflectorReflection(), new ReflectorReflectionWithCache(), new ReflectorJavassist(), new ReflectorJavaCompilerAPI() };
	static Reflector_Interface[] reflector_arr = { new ReflectorReflection(), new ReflectorReflectionWithCache(), new ReflectorJavassist(), new ReflectorJavaCompilerAPI(), new ReflectorJasmin() };

	
	static String[] methodNames	= { "static_test1", "static_test2", "static_test3", "test1", "test2", "test3" };
	static Object[][] argses		= { new Object[0], { new Integer(1) }, { new String() }, new Object[0], { new Integer(0) }, { new String() } };

	static String[] methodExprains		= { "static(void)", "stacic(int)", "static(String)",
						"non-static(void)", "non-stacit(int)", "non-static(String)" };

	final static int[] COUNTS = { 1, 10, 100 };


	public static void hoge()
	{
	}
	
	public static int static_test1()
	{
		return 0;
	}
	public static int static_test2(int x)
	{
		return 0;
	}
	public static int static_test3(String a)
	{
		return 0;
	}


	public int test1()
	{
		return 0;
	}
	public Long test2(int x)
	{
		return 0L;
	}
	public int test3(String a)
	{
		return 0;
	}



	public static PerfResult exec( Reflector_Interface ri, Object instance, String methodName, Object[] args, String exprain, int count)
	{

		try
		{
			long start_time = System.nanoTime();

			for( int i=0; i < count;i++)
			{
				ri.invoke( instance, methodName, args );
			}	

			long end_time = System.nanoTime();


			String ri_name = ri.getClass().getName();
			long spend_time = end_time - start_time;

			// System.out.println( ri_name + "	" + exprain + "	" + count + "̌Ăяo " + spend_time + " ns" );

			PerfResult pr 			= new PerfResult();
			pr.methodName			= methodName;
			pr.exprain			= exprain;
			pr.callCount			= count;
			pr.usedReflector		= ri;
			pr.spendNanoSeconds		= spend_time;

			return pr;
		}
		catch(Exception e )
		{
			e.printStackTrace();
		}

		return null;

	}


	public static PerfResultRow execRow( Reflector_Interface ri, Object[] instances, String[] methodNames, Object[][] argses, String[] exprains, int[][] callCounts)
	{
		//郊tN^IuWFNgɑ΂ÃeXg\bhAšʂԂ.


		String ri_name = ri.getClass().getName();

		PerfResultRow row	= new PerfResultRow();
		row.rowName		= ri_name;

		for( int i=0; i < methodNames.length; i++)
		{
			for( int c_index=0; c_index < callCounts[i].length; c_index++ )
			{
				PerfResult pr = exec( ri, instances[i], methodNames[i], argses[i], exprains[i], callCounts[i][ c_index ] );
				
				row.perfResults.add( pr );
				
				//String columnName = exprains[i] + " " + callCounts[i][c_index] + " callTimes (ns)";
				String columnName = exprains[i] + " " + callCounts[i][c_index];
				
				row.columnNames.add( columnName );
			}
		}

		return row;
	}

	public static PerfResultSet execSet( Reflector_Interface[] ri_arr, Object[] instances, String[] methodNames, Object[][] argses, String[] exprains, int[][] callCounts)
	{
		PerfResultSet set = new PerfResultSet();

		for( int i=0; i < ri_arr.length; i++)
		{
			PerfResultRow row = execRow( ri_arr[i], instances, methodNames, argses, exprains, callCounts );
			set.rows.add( row );
		}

		return set;
	}


	public static void main(String[] args)
	{

		/*
		for( int i=0; i < COUNTS.length; i++)
		{
			for( int k=0; k < reflector_arr.length; k++)
			{
				for( int meth_index = 0; meth_index < methodNames.length; meth_index++ )
				{
					PrefResult pr = exec( reflector_arr[k], new Performance(), methodNames[ meth_index], argses[ meth_index], methodExprains[ meth_index], COUNTS[k] );

					
				}
			}
		}
		*/

		for( int i=0; i < reflector_arr.length; i++)
		{
			if ( reflector_arr[i] instanceof ReflectorJavassist )
			{
				// javassistptN^NX͏̏d̂ŎOɓKȃ\bhĂ.
				Reflector_Interface ri = reflector_arr[i];
				Object instance = new Performance();
				Object[] tmp_args	= new Object[0];
				try
				{
					ri.invoke( instance, "hoge", tmp_args);
				}
				catch (Exception e )
				{
					e.printStackTrace( System.err );
				}
			}
		}


		int[][] callCounts = new int[ methodNames.length][];
		Object[] instances = new Object[ methodNames.length ];
		for( int i=0; i < callCounts.length; i++)
		{
			callCounts[i] = COUNTS;
			instances[i] = new Performance();
		}
		PerfResultSet set = execSet( reflector_arr, instances, methodNames, argses, methodExprains, callCounts );

		String csvStr = set.toCSV();

		{
			// ʏ̃\bhĂяo̎ԂKv.

			Performance instance = new Performance();

			PerfResultRow row = new PerfResultRow();
			row.rowName = "ʏ̃\bhĂяo";
			{


				for( int i=0; i < COUNTS.length; i++)
				{
					long startTime = System.nanoTime();
					for( int c_index=0; c_index < COUNTS[i]; c_index++)
					{
						static_test1();
					}
					long endTime = System.nanoTime();

					PerfResult pr = new PerfResult();
					pr.methodName	= methodNames[0];
					pr.exprain	= methodExprains[0];
					pr.callCount	= COUNTS[i];
					pr.spendNanoSeconds = endTime - startTime;
					row.perfResults.add( pr );
				}
			}

			{
				for( int i=0; i < COUNTS.length; i++)
				{
					long startTime = System.nanoTime();
					for( int c_index=0; c_index < COUNTS[i]; c_index++)
					{
						static_test2(i);
					}
					long endTime = System.nanoTime();

					PerfResult pr = new PerfResult();
					pr.methodName	= methodNames[1];
					pr.exprain	= methodExprains[1];
					pr.callCount	= COUNTS[i];
					pr.spendNanoSeconds = endTime - startTime;
					row.perfResults.add( pr );
				}
			}


			{
				String a = new String();
				for( int i=0; i < COUNTS.length; i++)
				{
					long startTime = System.nanoTime();
					for( int c_index=0; c_index < COUNTS[i]; c_index++)
					{
						static_test3(a);
					}
					long endTime = System.nanoTime();

					PerfResult pr = new PerfResult();
					pr.methodName	= methodNames[2];
					pr.exprain	= methodExprains[2];
					pr.callCount	= COUNTS[i];
					pr.spendNanoSeconds = endTime - startTime;
					row.perfResults.add( pr );
				}

			}

			{

				for( int i=0; i < COUNTS.length; i++)
				{
					long startTime = System.nanoTime();
					for( int c_index=0; c_index < COUNTS[i]; c_index++)
					{
						instance.test1();
					}
					long endTime = System.nanoTime();

					PerfResult pr = new PerfResult();
					pr.methodName	= methodNames[3];
					pr.exprain	= methodExprains[3];
					pr.callCount	= COUNTS[i];
					pr.spendNanoSeconds = endTime - startTime;
					row.perfResults.add( pr );
				}

			}
			{

				for( int i=0; i < COUNTS.length; i++)
				{
					long startTime = System.nanoTime();
					for( int c_index=0; c_index < COUNTS[i]; c_index++)
					{
						instance.test2(i);
					}
					long endTime = System.nanoTime();

					PerfResult pr = new PerfResult();
					pr.methodName	= methodNames[4];
					pr.exprain	= methodExprains[4];
					pr.callCount	= COUNTS[i];
					pr.spendNanoSeconds = endTime - startTime;
					row.perfResults.add( pr );
				}

			}
			{
				String a = new String();
				for( int i=0; i < COUNTS.length; i++)
				{
					long startTime = System.nanoTime();
					for( int c_index=0; c_index < COUNTS[i]; c_index++)
					{
						instance.test3(a);
					}
					long endTime = System.nanoTime();

					PerfResult pr = new PerfResult();
					pr.methodName	= methodNames[5];
					pr.exprain	= methodExprains[5];
					pr.callCount	= COUNTS[i];
					pr.spendNanoSeconds = endTime - startTime;
					row.perfResults.add( pr );
				}

			}

			csvStr += row.toCsvRow();

		}





		System.out.println(csvStr );


	}

	
}


	class PerfResultSet
	{
		//茋ʂ̍s.
		ArrayList<PerfResultRow> rows = new ArrayList();

		public String toCSV()
		{
			String csv = "";

			csv += "tN^";

			ArrayList<String>columnNames = rows.get(0).columnNames;
			for( int i=0; i < columnNames.size(); i++)
			{
				csv += "," + columnNames.get(i);
			}
			
			csv += "\n";

			for( int i=0; i < rows.size(); i++)
			{
				PerfResultRow row = rows.get(i);
				csv += row.toCsvRow();
				csv +="\n";
			}

			return csv;
		}

	}


	class PerfResultRow
	{

		//茋ʂ̍s
		String	rowName;
		ArrayList<String> columnNames = new ArrayList();
		ArrayList<PerfResult> perfResults	= new ArrayList();

		public String toCsvRow()
		{
			String row = "";

			row += rowName;
			
			for( int i=0; i < perfResults.size(); i++)
			{
				// row += "," + perfResults.get(i).spendNanoSeconds;
				row += "," + perfResults.get(i).spendNanoSeconds / 1000;
				//Ƃ肠}CNbPʂŏo.
			}

			return row;
		}

	}


	class PerfResult
	{
		Reflector_Interface usedReflector;
		
		String	methodName;
		String	exprain;

		int callCount;

		long	spendNanoSeconds;

	}



